#!/bin/bash


# #################################################
# helper functions
# #################################################
function display_help()
{
    echo "hipCUB build & installation helper script"
    echo "./install [-h|--help] "
    echo "    [-h|--help] prints this help message"
    echo "    [-i|--install] install after build"
    echo "    [-p|--package build package"
    echo "    [-r]--relocatable] create a package to support relocatable ROCm"
    echo "    [-b|--benchmark] builds and runs benchmark"
    echo "    [-d|--dependencies] install build dependencies"
    echo "    [-c|--clients] build library clients too (combines with -i & -d)"
    echo "    [-g|--debug] -DCMAKE_BUILD_TYPE=Debug (default is =Release)"
    echo "    [--hip-clang] build library for amdgpu backend using hip-clang"
    echo "    [--address-sanitizer] build with address sanitizer enabled"
    echo "    [--rm-legacy-include-dir] Remove legacy include dir Packaging added for file/folder reorg backward compatibility"
}


# #################################################
# global variables
# #################################################
install_package=false
build_package=false
build_clients=false
build_release=true
build_hip_clang=false
run_tests=false
rocm_path=/opt/rocm
build_relocatable=false
install_dependencies=false
build_address_sanitizer=false
build_benchmark=false
build_freorg_bkwdcomp=true

# #################################################
# Parameter parsing
# #################################################

# check if we have a modern version of getopt that can handle whitespace and long parameters
getopt -T
if [[ $? -eq 4 ]]; then
    GETOPT_PARSE=$(getopt --name "${0}" --longoptions help,install,clients,debug,hip-clang,test,benchmark,package,relocatable,dependencies,address-sanitizer,rm-legacy-include-dir --options hicdtbpr -- "$@")
else
    echo "Need a new version of getopt"
    exit 1
fi

if [[ $? -ne 0 ]]; then
    echo "getopt invocation failed; could not parse the command line";
    exit 1
fi

eval set -- "${GETOPT_PARSE}"

check_exit_code( )
{
    if (( $1 != 0 )); then
    exit $1
    fi
}

while true; do
    case "${1}" in
    -h|--help)
        display_help
        exit 0
        ;;
    -i|--install)
        install_package=true
        shift ;;
    -p|--package)
        build_package=true
        shift ;;
    -c|--clients)
        build_clients=true
        shift ;;
    -r|--relocatable)
        build_relocatable=true
        shift ;;
    -g|--debug)
        build_release=false
        shift ;;
    -t|--test)
        run_tests=true
        shift ;;
    -b|--benchmark)
        build_benchmark=true
        shift ;;
    -d|--dependencies)
        install_dependencies=true
        shift ;;
    --hip-clang)
        build_hip_clang=true
        shift ;;
    --address-sanitizer)
        build_address_sanitizer=true
        shift ;;
    --rm-legacy-include-dir)
        build_freorg_bkwdcomp=false
        shift ;;
    --) shift ; break ;;
    *)  echo "Unexpected command line parameter received; aborting";
        exit 1
        ;;
    esac
    done

if [[ "${build_relocatable}" == true ]]; then
    if ! [ -z ${ROCM_PATH+x} ]; then
        rocm_path=${ROCM_PATH}
    fi
fi

# Install the pre-commit hook
bash .githooks/install


# Create and go to the build directory.
mkdir -p build; cd build

if ($build_release); then
    mkdir -p release; cd release
    build_type="-DCMAKE_BUILD_TYPE=Release"
else
    mkdir -p debug; cd debug
    build_type="-DCMAKE_BUILD_TYPE=Debug"
fi

# Configure hipCUB, setup options for your system.
# Build options:
#   BUILD_TEST - off by default,
#   BUILD_BENCHMARK - off by default.
#
compiler="hipcc"

cmake_executable="cmake"

cmake_common_options=""

if [[ "${build_benchmark}" == true ]]; then
    build_benchmarks="-DBUILD_BENCHMARK=ON"
fi

if [[ "${build_clients}" == true ]]; then
    build_tests="-DBUILD_TEST=ON"
else
    build_tests="-DBUILD_TEST=OFF"
fi

if [[ "${build_address_sanitizer}" == true ]]; then
    cmake_common_options="$cmake_common_options -DBUILD_ADDRESS_SANITIZER=ON"
fi

if ($install_dependencies); then
    cmake_common_options="${cmake_common_options} -DDEPENDENCIES_FORCE_DOWNLOAD=ON"
fi

if [[ "${build_relocatable}" == true ]]; then
    CXX=$rocm_path/bin/${compiler} ${cmake_executable} \
        -DCMAKE_INSTALL_PREFIX=${rocm_path} \
        -DCMAKE_MODULE_PATH="${rocm_path}/lib/cmake/hip ${rocm_path}/hip/cmake" \
        -Drocprim_DIR=${rocm_path}/rocprim \
        ${cmake_common_options} \
        ${build_tests} ${build_benchmarks} ${build_type} ../../. # or cmake-gui ../.
else
    CXX=$rocm_path/bin/${compiler} ${cmake_executable} ${build_tests} ${build_benchmarks} ${build_type} ${cmake_common_options} ../../. # or cmake-gui ../.
fi
check_exit_code "$?"

# Build
make -j$(nproc)
check_exit_code "$?"

if ($run_tests); then
# Optionally, run tests if they're enabled.
ctest --output-on-failure
fi

if ($install_package); then
    # Install
    make install
    check_exit_code "$?"
fi

if ($build_package); then
    # Package
    make package -j$(nproc)
    check_exit_code "$?"
fi
